/* =============================================================================================================
	Logger 0.1
================================================================================================================

	GJS logger service

	Copyright (c) 2016, 2nv2u <info@2nv2u.com>
	This work is distributed under GPLv3, see LICENSE for more information.
============================================================================================================= */

const Lang = imports.lang;

const Level = {
	DEBUG: 0,
	INFO: 1,
	WARN: 2,
	ERROR: 3
};

const Service = new Lang.Class({
	Name: 'Service',
	_levels: [],

	_init: function(level,prefix){
		this._level = level;
		this._prefix = prefix;
		let i = 0;
		for(let name in Level){
			this._levels[i] = name;
			i++;
		}
	},

	logCollection: function(level,collection){
		if(level >= this._level){
			let args = Array.prototype.slice.call(collection);
			args.unshift(level);
			this.log.apply(this,args);
		}
	},

	log: function(level){
		if(level >= this._level){
			let args = Array.prototype.slice.call(arguments);
			for(let i=0;i<args.length;i++){
				if(i == 0){
					args[i] = this._prefix+':'+this._levels[level]
				} else if(typeof args[i] != 'string'){
					args[i] = JSON.stringify(args[i]);
				}
			}
			log.apply(this,args);
		}
	},

	debug: function(){
		this.logCollection(Level.DEBUG,arguments);
	},

	info: function(){
		this.logCollection(Level.INFO,arguments);
	},

	warn: function(){
		this.logCollection(Level.WARN,arguments);
	},

	error: function(){
		this.logCollection(Level.ERROR,arguments);
	}
});
